package
{
	import flash.desktop.NativeApplication;
	import flash.desktop.SystemIdleMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.GeolocationEvent;
	import flash.events.KeyboardEvent;
	import flash.net.SharedObject;
	import flash.ui.Keyboard;
	
	public class Application extends Sprite
	{
		static private const CONVERSION_BASE :Number = 2.2369362920544;
		
		public  var speedometer  :Speedometer;
		private var geolocation  :IGeolocation;
		private var sharedObject :SharedObject;
		
		public function Application()
		{
			NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.KEEP_AWAKE;
			NativeApplication.nativeApplication.addEventListener( KeyboardEvent.KEY_DOWN, handleKeyDown );
			NativeApplication.nativeApplication.addEventListener( Event.DEACTIVATE, handleDeactivate );
			
			CONFIG::GEOLOCATION_SIMULATE
			{
				geolocation = new GeolocationSimulate();
			}
			
			CONFIG::GEOLOCATION_REAL
			{
				geolocation = new GeolocationReal();
			}
			
			geolocation.setRequestedUpdateInterval( 1000 );
			geolocation.addEventListener( GeolocationEvent.UPDATE, handleGeolocationUpdate );
			
			sharedObject = SharedObject.getLocal( "speedometer" );
			if( sharedObject.size == 0 )
			{
				sharedObject.data.distance = 0;
			}
			speedometer.distance = sharedObject.data.distance;
		}
		
		private function handleGeolocationUpdate( e :GeolocationEvent ) :void
		{
			speedometer.speed = e.speed;
		}
		
		private function handleKeyDown( e :KeyboardEvent ) :void
		{
			switch( e.keyCode )
			{
				case Keyboard.BACK:
					NativeApplication.nativeApplication.exit();	
					break;
				
				case Keyboard.SEARCH:
				case Keyboard.MENU:
					e.preventDefault();
					break;				
			}
		}
		
		private function handleDeactivate( e :Event ) :void
		{
			sharedObject.data.distance = speedometer.distance;
			sharedObject.flush();

			NativeApplication.nativeApplication.exit();
		}
		
		private function convertToMilesPerHour( metresPerSecond :Number ) :Number
		{
			return metresPerSecond * CONVERSION_BASE;
		}
	}
}