package
{
	import flash.display.MovieClip;
	
	public class Counter extends MovieClip
	{
		public var d0 :Digit;
		public var d1 :Digit;
		public var d2 :Digit;
		public var d3 :Digit;
		public var d4 :Digit;
		public var d5 :Digit;
		public var d6 :Digit;
		public var d7: Digit;
		
		private var digits :Vector.<Digit>;
		private var dist   :Number;
		
		public function Counter()
		{
			digits = new <Digit>[ d7, d6, d5, d4, d3, d2, d1, d0 ];
			dist   = 0;
		}
		
		public function set distance( value :Number ) :void
		{
			dist = value;
			updateDigits();
		}
		
		public function get distance() :Number
		{
			return dist;
		}
		
		private function updateDigits() :void
		{
			// Convert the distance to a string.
			var distString :String = String( dist );
			
			// If the string is too long then reduce it.
			// If the string is too short then pad the beginning out with some zeros.
			if( distString.length > digits.length )
			{
				distString = distString.substr( ( distString.length - digits.length ), digits.length );
			}
			else if( distString.length < digits.length )
			{
				distString = createZerosString( digits.length - distString.length ) + distString;
			}
			
			// Walk the string and assign each digit a value from the string.
			var digit :Digit;
			for( var i :int = 0; i < digits.length; i++ )
			{
				digit = digits[ i ];
				digit.value = parseInt( distString.substr( i, 1 ) );
			}
		}
		
		private function createZerosString( count :uint ) :String
		{
			var s :String = "";
			for( var i :uint = 0; i < count; i++ )
			{
				s += "0";
			}
			return s;
		}
	}
}
