package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import com.greensock.TweenLite;
	import com.greensock.easing.Linear;
	
	public class Digit extends MovieClip
	{
		static private const DIGIT_HEIGHT :uint = 25;
		static private const DIGIT_WIDTH  :uint = 23;
		
		public  var column  :MovieClip;
		private var currVal :int;
		private var prevVal :int;
		
		public function Digit()
		{
			currVal = -1;
			prevVal = -1;
			scrollRect = new Rectangle( 0, 0, DIGIT_WIDTH, DIGIT_HEIGHT );
		}
		
		public function set value( value :int ) :void
		{
			// Set the digit's value.
			prevVal = currVal;
			currVal = value % 10;
			
			// If it's the first time then snap to the value.
			// Otherwise move to the value.
			if( prevVal == -1 )
			{
				snapColumn();
			}
			else
			{
				moveColumn();
			}
		}
		
		public function get value() :int
		{
			return currVal;
		}
		
		private function snapColumn() :void
		{
			column.y = -currVal * DIGIT_HEIGHT;
		}
		
		private function moveColumn() :void
		{
			// Stop the column from animating.
			TweenLite.killTweensOf( column );
			
			// Ensure that we start from the top-half of the column.
			if( column.y < -( DIGIT_HEIGHT * 10 ) )
			{
				column.y += ( DIGIT_HEIGHT * 10 );
			}
			
			// Find out the number we are currently stopped at.
			var valStoppedAt :int = Math.abs( column.y / DIGIT_HEIGHT );
			
			// Calculate the y-position the column needs to be moved to to
			// show the new current number.
			var targY :Number = -currVal * DIGIT_HEIGHT;
			
			// If the new current value is less than the value we stopped at
			// then we need to simulate the digit wrapping back round. To do
			// this, we'll scroll into the bottom-half of the column.
			if( currVal < valStoppedAt )
			{
				targY -= ( DIGIT_HEIGHT * 10 );			
			}
			
			// Perform the actual scroll animation on the column.
			var duration :uint = Math.abs( column.y - targY ) / DIGIT_HEIGHT;
			TweenLite.to( column, duration, { y: targY, ease:Linear.easeNone } );
		}
	}
}
