package
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Matrix;
	import com.greensock.TweenLite;
	
	public class Speedometer extends Sprite
	{
		/*
			Constants
		*/
		
		static private const SPEED_CONVERSION_BASE    :Number =  2.2369362920544;
		static private const ROTATION_CONVERSION_BASE :Number =  1.671428571;
		static private const START_ROTATION           :Number = -117
		static private const MAX_SPEED_INCREASE       :Number =  20;
		static private const DISTANCE_CONVERSION_BASE :Number =  0.000621371192237334;
		
		/*
			Member Variables
		*/
		
		public  var arrow               :MovieClip;
		public  var counter             :Counter;
		private var currMetresPerSecond :Number;
		private var dist                :Number;
		
		
		/*
			Class Methods
		*/
		
		public function Speedometer()
		{	
			currMetresPerSecond = 0;
			dist = 0;
			addEventListener( Event.ADDED_TO_STAGE, handleAddedToStage );
		}
		
		public function set speed( metresPerSecond :Number ) :void
		{			
			// Prevent geolocation errors from being used.
			if( Math.abs( currMetresPerSecond - metresPerSecond ) < MAX_SPEED_INCREASE )
			{
				currMetresPerSecond = metresPerSecond;
			}
			
			var milesPerHour :Number = convertToMilesPerHour( currMetresPerSecond );
			TweenLite.to( arrow, 1, { rotation: convertToRotation( milesPerHour ) } );
			
			dist += currMetresPerSecond;
			counter.distance = Math.floor( convertToMiles( dist ) );
		}
		
		public function set distance( metres :Number ) :void
		{
			dist = metres;
			counter.distance = Math.floor( convertToMiles( dist ) );
		}
				
		public function get distance() :Number
		{
			return dist;
		}
		
		private function handleAddedToStage( e :Event ) :void
		{
			removeEventListener( Event.ADDED_TO_STAGE, handleAddedToStage );			
			
			mouseEnabled  = false;
			mouseChildren = false;
			
			arrow.cacheAsBitmap = true;
			arrow.cacheAsBitmapMatrix = new Matrix();
	
			arrow.rotation = START_ROTATION;
		}
		
		private function convertToRotation( milesPerHour ) :Number
		{
			return START_ROTATION + ( milesPerHour * ROTATION_CONVERSION_BASE );
		}
		
		private function convertToMilesPerHour( metresPerSecond :Number ) :Number
		{
			return metresPerSecond * SPEED_CONVERSION_BASE;
		}
		
		private function convertToMiles( metres :Number ) :Number
		{
			return metres * DISTANCE_CONVERSION_BASE;
		}
	}
}
